package tech.sbdevelopment.v10lift.locale;

import co.aikar.locales.MessageKey;
import co.aikar.locales.MessageKeyProvider;

public enum Message implements MessageKeyProvider {
    GENERAL_NOPERMISSION,
    GENERAL_PLAYERONLY,
    GENERAL_INCORRECTUSAGE,
    GENERAL_INTERNALERROR,
    GENERAL_DOESNTEXISTS,
    GENERAL_ALREADYEXISTS,
    GENERAL_SWITCHONEDIT,
    GENERAL_DETECTIONFAILED,
    GENERAL_FLOORDOESNTEXISTS,
    GENERAL_NOWHITELISTPERMISSION,
    GENERAL_NOFLOORS,
    GENERAL_REMOVELIFFTFIRST,
    GENERAL_REMOVEROPEFIRST,
    GENERAL_REMOVEDOORFIRST,
    CREATE_ADDBLOCKS,
    CREATE_NOBLOCKS,
    CREATE_CREATED,
    DELETE_NOTREMOVED,
    DELETE_REMOVED,
    RENAME_RENAMED,
    EDIT_STILLINEDITMODE,
    EDIT_TURNEDON,
    EDIT_TURNEDOFF,
    FLOOR_TOHIGH,
    FLOOR_ALREADYEXISTS,
    FLOOR_DOESNTEXISTS,
    FLOOR_ADDED,
    FLOOR_REMOVED,
    FLOOR_RENAMED,
    INPUT_STILLADJUSTING,
    INPUT_NOTHINGTOREMOVE,
    INPUT_ALREADYADDED,
    INPUT_NOINPUT,
    INPUT_RIGHTCLICK,
    INPUT_CREATED,
    INPUT_REMOVED,
    OFFLINEINPUT_STILLADJUSTING,
    OFFLINEINPUT_NOTHINGTOREMOVE,
    OFFLINEINPUT_ALREADYADDED,
    OFFLINEINPUT_NOINPUT,
    OFFLINEINPUT_RIGHTCLICK,
    OFFLINEINPUT_CREATED,
    OFFLINEINPUT_REMOVED,
    BUILD_DISABLED,
    BUILD_ENABLED,
    BUILD_BLOCKADDED,
    BUILD_BLOCKREMOVED,
    BUILD_BLACKLISTEDMATERIAL,
    BUILD_NOSELECTION,
    BUILD_UNSUPPORTEDSELECTION,
    BUILD_BLOCKSADDED,
    BUILD_BLOCKSFAILED,
    BUILD_WORLDEDITNOTENABLED,
    ROPE_STILLADJUSTING,
    ROPE_ONLYUP,
    ROPE_ONLYONEMATERIAL,
    ROPE_ALREADYAROPE,
    ROPE_NOTAROPE,
    ROPE_BLACKLISTEDMATERIAL,
    ROPE_ADD,
    ROPE_DELETE,
    ROPE_CLICKONEND,
    ROPE_PARTREMOVED,
    ROPE_CREATED,
    ROPE_REMOVED,
    DOOR_BLACKLISTEDMATERIAL,
    DOOR_DISABLED,
    DOOR_ENABLED,
    DOOR_CREATED,
    DOOR_REMOVED,
    WHITELIST_GROUP_VAULTNOTFOUND,
    WHITELIST_GROUP_NOTFOUND,
    WHITELIST_GROUP_ALREADYCONTAINS,
    WHITELIST_GROUP_DOESNTCONTAINS,
    WHITELIST_GROUP_ADDED,
    WHITELIST_GROUP_REMOVED,
    WHITELIST_PLAYER_NOTFOUND,
    WHITELIST_PLAYER_ALREADYCONTAINS,
    WHITELIST_PLAYER_DOESNTCONTAINS,
    WHITELIST_PLAYER_ADDED,
    WHITELIST_PLAYER_REMOVED,
    WHOIS_USEWITHOUTNAME,
    WHOIS_NOTALIFT,
    WHOIS_WITHOUTNAME,
    SPEED_WRONGSPEED,
    SPEED_CHANGED,
    SOUND_TURNEDON,
    SOUND_TURNEDOFF,
    REALISTIC_TURNEDON,
    REALISTIC_TURNEDOFF,
    DISABLE_ALREADYDEFECTIVE,
    DISABLE_DISABLED,
    REPAIR_NOTDEFECTIVE,
    REPAIR_ITEMSNEEDED,
    REPAIR_REPAIRED,
    ABORT_NOTHINGTOCANCEL,
    ABORT_CANCELLED,
    RELOAD_RELOADED,
    START_NONPLAYER,
    START_STARTED,
    STOP_NONPLAYER,
    STOP_NOMOVINGTASKS,
    STOP_STOPPED,
    LIFTSIGN_NONAME,
    LIFTSIGN_CREATED,
    LIFTSIGN_REMOVED,
    LIST_NOLIFTS,
    LIST_HEADER,
    LIST_LIFT,
    SETOFFLINE_DISABLED,
    SETOFFLINE_ENABLED;

    private final MessageKey key;

    Message() {
        this.key = MessageKey.of(convertConstantToLanguageKey("v10lift." + this.name()));
    }

    @Override
    public MessageKey getMessageKey() {
        return this.key;
    }

    private static String convertConstantToLanguageKey(String constant) {
        StringBuilder languageKey = new StringBuilder();
        String[] words = constant.split("_");

        for (int i = 0; i < words.length; i++) {
            String word = words[i].toLowerCase();
            if (i > 0) {
                languageKey.append(".");
            }
            languageKey.append(word);
        }

        return languageKey.toString();
    }
}
